part of dhilla;

class StaticFileHandler implements Function {
  final String rootDirectory,
               prefix;

  StaticFileHandler(this.rootDirectory, this.prefix);

  Request call(Request request) {
    var path = request.path;

    if (isStatic(path)) {
      var modifiedPath = modifyPath(path),
          response = request.response;

      response
        .sendFile(modifiedPath)
        .catchError((error, stackTrace) {
          response
            ..statusCode = HttpStatus.NOT_FOUND
            ..send('Cannot found the following file at: $modifiedPath');
        });

    } else {
      return request;
    }
  }

  bool isStatic(String path) => path.startsWith(prefix);

  String modifyPath(String path) {
    var length = prefix.length,
        prefixRemoved = path.replaceFirst(prefix, ''),
        modified = '$rootDirectory$prefixRemoved';

    return modified;
  }
}